/* ====================================================================
 *
 *
 * Copyright (c) 1999-2002 CPortals Systems, Inc.  All rights reserved.
 *
 * This file is part of OSMQ.
 *
 *   OSMQ is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   OSMQ is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with OSMQ; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 * OSMQ is a trademark of CPortals Systems, Inc.
 * ====================================================================
 */


package osmq.datarows;

import java.math.BigDecimal;
import java.util.Date;
import osmq.util.KeyedData;

/**
  * A multi-element container that sets and returns its elements as
  * either Strings or scalar data types. The DataType supports
  * mapping data as an int, double, long, char and String.
  * The elements are referenced positionally (1-n).
  * The DataRecord's getElementCount() returns the number of element
  * in the container.
  * This interface is modeled after the JDBC ResultSet and Statement relative
  * to getXXX and setXXX methods.
  */

public interface KeyedDataRow extends DataRow, KeyedData
  {
 
   }



