/* ====================================================================
 *
 *
 * Copyright (c) 1999-2002 CPortals Systems, Inc.  All rights reserved.
 *
 * This file is part of OSMQ.
 *
 *   OSMQ is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   OSMQ is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with OSMQ; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 * OSMQ is a trademark of CPortals Systems, Inc.
 * ====================================================================
 */

package osmq.datatypes;

import java.text.*;

/**
  * An immutable data type representing Rate.
  */
public class Rate extends Decimal
  {
  private static FactorUtil _facutil;

  public Rate()
     {}

  public Rate(Decimal value)
     {super(value);}

  public Rate(double value)
     {
     super(value);
     }

  public Rate(int value)
     {
     super(value);
     }

  public Rate(String value)
     {
     super(value);
     }

  protected int getFactor(){return getFactorUtil().getFactor();}
  protected int getDecPlaces(){return getFactorUtil().getDecPlaces();}
  protected String getFormatMask(){return getFactorUtil().getFormatMask();}

   private static FactorUtil getFactorUtil()
      {
      if(_facutil == null)
         {
         synchronized(Rate.class)
            {
            if(_facutil == null)
               _facutil = new FactorUtil(5);
            }
         }
      return _facutil;
      }


   public static void main(String[] args)
      {
      Rate p = new Rate("10000.00");
      System.out.println(p.getString());
          System.out.println("divided by 3 = " + p.dividedBy(3));
      System.out.println("add 55.34 = " + p.add(55.34));
      System.out.println("multiply by 10 = " + p.times(10));
      System.out.println("Divide by 10 = " + p.dividedBy(10));
      System.out.println("divided by 5 = " + p.dividedBy(5));
      System.out.println("divided by 3 = " + p.dividedBy(3));
      System.out.println("formatted = " + p.getFormattedString());
      }

   }





