/* ====================================================================
 *
 *
 * Copyright (c) 1999-2002 CPortals Systems, Inc.  All rights reserved.
 *
 * This file is part of OSMQ.
 *
 *   OSMQ is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   OSMQ is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with OSMQ; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 * OSMQ is a trademark of CPortals Systems, Inc.
 * ====================================================================
 */

package osmq.logs;

import java.io.OutputStream;
import java.io.IOException;
import osmq.util.DateStamp;

class LogWrapper implements Log
   {
   private boolean isAFile = false;
   public  Log instance;
   private String name = null;

   LogWrapper()
      {instance = new DummyLog();}

   public LogWrapper(Log v)
      {
	   setLog(v);
	   }

   public LogWrapper(OutputStream s)
      {
      setStream(s);
      }

   public void setStream(OutputStream s)
      {
     // if(s instanceof OutputTextStream)
      //   instance = (OutputTextStream)s;
     // else
         instance = new PrintWriterLog(s);
      }

   public void setDummy()
      {
      instance = new DummyLog();
      }

   public void println(String s)
      {instance.println(s);}

   public void setDated(boolean b)
      {
      instance.setDated(b);
      }

   public boolean getDated()
      {
      return instance.getDated();
      }

   public void setTimed(boolean b)
      {
      instance.setTimed(b);
      }

   public boolean getTimed()
      {
      return instance.getTimed();
      }

   public void close() throws IOException
      {
      instance.close();
      }
   
   public void setLog(Log v)
      {
      instance = v;
      }
	  
    public void setFile(String v, boolean append)
	   {
	   try{instance = new PrintWriterLog(v, append);}
       catch(Exception e){instance = new DummyLog();}
	   }
      
	public void setLogFile(String v, boolean append)
	   {
	   setFile(v + ".log", append);
	   }

	public void setDayLogFile(String v, boolean append)
	   {
	   setFile(v + DateStamp.getDayStamp() + ".log", append);
	   }

   }

