/* ====================================================================
 *
 *
 * Copyright (c) 1999-2002 CPortals Systems, Inc.  All rights reserved.
 *
 * This file is part of OSMQ.
 *
 *   OSMQ is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   OSMQ is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with OSMQ; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 * OSMQ is a trademark of CPortals Systems, Inc.
 * ====================================================================
 */

package osmq.logs;

import java.io.*;

public class Logs
   {
   public static LogSet log = new LogSet();

   public static Log err = log.err;
   public static Log out = log.out;
   public static Log audit = log.audit;
   public static Log trace = log.trace;
   public static Log vis = log.vis;
   public static Log safestore = log.safestore;

   public static void setErr(OutputStream s)
      {
      log.err.setStream(s);
      }

   public static void setOut(OutputStream s)
      {
      log.out.setStream(s);
      }

   public static void setTrace(OutputStream s)
      {
      log.trace.setStream(s);
      }

   public static void setVis(Log p)
      {
      log.vis.setLog(p);
      }

   public static void setAudit(Log p)
      {
      log.audit.setLog(p);
      }

   // create an actual audit log (rather than the default dummy)
   public static void useAudit(boolean b)
      {
      if(b)
        log.audit.setDayLogFile("audit", true);
      else
        log.audit.setDummy();
      log.audit.setTimed(true);
      }

    // create an actual audit log (rather than the default dummy)
   public static void useSafeStore(boolean b)
      {
      if(b)
        log.safestore.setLogFile("safestore", true);
      else
        log.safestore.setDummy();
      
      }

   public static void useErrLogFile(boolean b)
     {
     if (b)
        {
        log.err.setLogFile("error", true);
        log.err.setTimed(true);
        }
     else
        err = new LogWrapper(System.err);
     }

   public static void useTrace(boolean b)
      {
       if(b)
        log.trace.setLogFile("trace", true);
      else
        log.trace.setDummy();
      log.trace.setTimed(true);
      }

   public static void closeLogs()
      {
      log.closeLogs();
      }
   }


