/* ====================================================================
 *
 *
 * Copyright (c) 1999-2002 CPortals Systems, Inc.  All rights reserved.
 *
 * This file is part of OSMQ.
 *
 *   OSMQ is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   OSMQ is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with OSMQ; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 * OSMQ is a trademark of CPortals Systems, Inc.
 * ====================================================================
 */

package osmq.mque;

import java.util.*;
import java.io.*;

import osmq.io.*;


class PacketFileLoader
  {
  String myname;
  PacketInputStream is;

  public PacketFileLoader(String filename) throws FileNotFoundException, IOException
     {
     is = new ZipPacketFileInputStream(filename);
     myname = filename;
     }

  private void clear()
     {
     File tmp = new  File(myname);
     tmp.delete();
     }


  protected void finalize() throws Throwable
      {
      is.close();
      }

  public void loadQueue(MQue f) throws IOException
     {
     try{
        while(!is.isEOF())
           f.writeBytes(is.readBytes());
        }
     catch(Exception e){}
     finally
        {
        is.close();
        clear();
        }
     is = null;
     }
  }

