/* ====================================================================
 *
 *
 * Copyright (c) 1999-2002 CPortals Systems, Inc.  All rights reserved.
 *
 * This file is part of OSMQ.
 *
 *   OSMQ is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   OSMQ is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with OSMQ; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 * OSMQ is a trademark of CPortals Systems, Inc.
 * ====================================================================
 */
 
package osmq.net;

import java.io.IOException;

public class RemoteServiceWrapper
  {
  RemoteService _rs;
  final private static char BINARY_MODE = 'B';

  private String _serviceid = null;
  private String _streamMode = null;
  private int    _port = 0;
  private String _hostname = null;

  public RemoteServiceWrapper()
     {_rs = new RemoteService();}
  public RemoteServiceWrapper(RemoteService rs)
     {_rs = rs;}

  public RemoteServiceWrapper(String serviceid)
      {
      _rs = new RemoteService(serviceid);
      }

  public RemoteServiceWrapper(String hostname, int port)
      {
      _rs = new RemoteService();
      _rs.setHostName(hostname);
      _rs.setPortID(port);
      }

  public RemoteService getRemoteService()
      {return _rs;}

   public boolean isNamed()
      {
      return _rs.isNamed();
      }

   public String getServiceID()
      {
      return _rs.getServiceID();
      }

   public void setServiceID(String serviceid)
      {
      _rs.setServiceID(serviceid);
      if(serviceid != null && serviceid.length() > 0)
         {
         _rs.setHostName(null);
         _rs.setPortID(0);
         }
      }

   public boolean isBinaryMode()
      {
      return _rs.isBinaryMode();
      }

   public String getStreamMode()
      {
      return _rs.getStreamMode();
      }

   public  void setStreamMode(String streamMode)
      {
      _rs.setStreamMode(streamMode);
      }

   public void clearAddress()
      {
      _rs.clearAddress();
      }

   public void setPortID(int port)
      {
      _rs.setPortID(port);
      if(port != 0)
         _rs.setServiceID(null);
      }
      
   public int getPortID()
      {
      return _rs.getPortID();
      }
      
   public boolean portIsSet()
      {
      return _rs.portIsSet();
      }

   public boolean hostNameIsSet()
      {
      return _rs.hostNameIsSet();
      }
      
   public void setHostName(String hostname)
      {
      _rs.setHostName(hostname);
      if(hostname != null && hostname.length() > 0)
          _rs.setServiceID(null);
      }
      
   public String getHostName()
      {
      return _rs.getHostName();
      }

   public String toString()
      {
      return _rs.toString();
      }
  }