/* ====================================================================
 *
 *
 * Copyright (c) 1999-2002 CPortals Systems, Inc.  All rights reserved.
 *
 * This file is part of OSMQ.
 *
 *   OSMQ is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   OSMQ is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with OSMQ; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 * OSMQ is a trademark of CPortals Systems, Inc.
 * ====================================================================
 */
 
package osmq.util;

public class DecimalConverter
   {
   private static int DEFAULT_PRECISION = 8;
   private double _value;
   private int decimals;
   private int DENOM_BASE;

   public DecimalConverter()
       {this(0.0);}
       
   public DecimalConverter(double value)
       {
       this(value, DEFAULT_PRECISION);
       }

   public DecimalConverter(double value, int precision)
       {
       setValue(value);
       setPrecision(precision);
       }

   public void setPrecision(int decimals)
      {
      DENOM_BASE = (int) Math.pow(10, decimals);
      this.decimals = decimals;
      }

   public int getPrecision()
      {return decimals;}
      
   public void setValue(double value)
      {_value = value;}

   public double getValue()
      {return _value;}

   public String setAndTranslate(double d)
      {
      setValue(d);
      return toString();
      }
      
   public String toString()
     {
     int  w = (int)  Math.floor(_value);
     int f = (int) ((_value - w) * (DENOM_BASE));
     while(f > 0 && f % 10 == 0)
         f /= 10;
     return new String(w + "." + f);
     }

   static void main(String[] args)
      {
      DecimalConverter dc = new DecimalConverter(12.345);
      DecimalConverter dc2 = new DecimalConverter(123.0);
      System.out.println(dc.toString());
      System.out.println(dc2.toString());
      }
   }