/* ====================================================================
 *
 *
 * Copyright (c) 1999-2002 CPortals Systems, Inc.  All rights reserved.
 *
 * This file is part of OSMQ.
 *
 *   OSMQ is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   OSMQ is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with OSMQ; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 * OSMQ is a trademark of CPortals Systems, Inc.
 * ====================================================================
 */
 
package osmq.util;

import java.util.*;

public class StateEventBean
  {
  public StateEventBean() {}

  public synchronized void addStateEventListener(StateEventListener l)
      {
      listenerList.addElement(l);
      }

  public synchronized void removeStateEventListener(StateEventListener l)
      {
      listenerList.removeElement(l);
      }

  public void fireSizeChangeEvent()
      {
      processStateEvent (new StateEvent (this, StateEvent.SIZE_CHANGE_EVENT));
      }

  public void fireSizeIncreaseEvent()
      {
      processStateEvent (new StateEvent (this, StateEvent.SIZE_INCREASE_EVENT));
      }

  public void fireSizeDecreaseEvent()
      {
      processStateEvent (new StateEvent (this, StateEvent.SIZE_DECREASE_EVENT));
      }

  public void fireTimeEvent()
      {
      processStateEvent (new StateEvent (this, StateEvent.TIME_EVENT));
      }

  public void fireStateEvent()
      {
      processStateEvent (new StateEvent (this, StateEvent.STATE_EVENT));
      }

  public void fireSuccessEvent()
      {
      processStateEvent (new StateEvent (this, StateEvent.SUCCESS_EVENT));
      }

  public void fireFailEvent()
      {
      processStateEvent (new StateEvent (this, StateEvent.FAIL_EVENT));
      }

  public void fireInitializationEvent()
      {
      processStateEvent (new StateEvent (this, StateEvent.INITIALIZATION_EVENT));
      }

  public void fireCloseEvent()
      {
      processStateEvent (new StateEvent (this, StateEvent.CLOSE_EVENT));
      }

  public void fireHaltEvent()
      {
      processStateEvent (new StateEvent (this, StateEvent.HALT_EVENT));
      }

  public void firePauseEvent()
      {
      processStateEvent (new StateEvent (this, StateEvent.PAUSE_EVENT));
      }

   public void fireUnpauseEvent()
      {
      processStateEvent (new StateEvent (this, StateEvent.UNPAUSE_EVENT));
      }

  protected void processStateEvent(StateEvent e)
    {
    for (int i=0; i<listenerList.size(); i++)
      ((StateEventListener)listenerList.elementAt(i)).onEvent(e);
    }

  // A test method to fire all 3 example events
  public void testStateEvent () {
    processStateEvent (new StateEvent (this, StateEvent.TIME_EVENT));
    processStateEvent (new StateEvent (this, StateEvent.SIZE_CHANGE_EVENT));
  }

  private Vector listenerList = new Vector();
}

